#ifndef __behaviors_notifications_h__
#define __behaviors_notifications_h__

// notification messages generated by behaviors
// which should be handled by host application

#include <windows.h>

#define WM_BEHAVIOR_NOTIFY (WM_USER + 100)

//---------------------------------------------------------------------
// external behaviors, implemented in /include/behaviors/*.cpp modules
//---------------------------------------------------------------------

#define MAX_URL_LENGTH 2048

// command behavior notification (behavior_command.cpp)
#define HLN_COMMAND_CLICK   (1) 
// command behavior is using this to send its "clicks"
struct NMHL_COMMAND_CLICK
{
  NMHDR    hdr;
  WCHAR    szElementID[MAX_URL_LENGTH];
  HELEMENT he;
};

// hyperlink behavior (behavior_hyperlink.cpp)
#define HLN_HYPERLINK       (2)  
// hyperlink behavior is using this to send its "clicks" state

struct NMHL_HYPERLINK
{
  enum type { ENTER = 1, LEAVE, CLICK };

  NMHDR hdr;
  type     action; 
  WCHAR    szHREF[MAX_URL_LENGTH];
  WCHAR    szTarget[MAX_URL_LENGTH];
  HELEMENT he;
};





#endif